/*
*ejemplo6_14.c
*/
#include <stdlib.h>
#include <stdio.h>

float **reservarMemoria(int fil, int col){
    float  **matrizDinamica;
    int j;

    matrizDinamica = (float **) malloc(fil * sizeof(float *));
    for (j = 0; j < fil; j++){
        matrizDinamica[j] = (float *)malloc(col * sizeof(float));
    }

    return matrizDinamica;
}

void leerMatriz(float **matriz, int fil, int col){
    int i, j;
    float dato;

    for (i = 0; i < fil; i++){
        for (j = 0; j < col; j++){
            printf("Elemento [%d,%d]: ", i,j);
            scanf("%f", &dato);
            matriz[i][j]=dato;
        }
        printf("\n");
    }
}

void imprimirMatriz(float **matriz, int fil, int col){
    int i, j;

    for (i = 0; i < fil; i++){
        for (j = 0; j < col; j++){
            printf("[ %e ] \t", matriz[i][j]);
        }
        printf("\n");
    }
}

void multiplicarMatriz(float **A, float **B, float **C, int dim){
    int i, j, k;

    for(i = 0; i < dim; i++){
        for(j = 0; j < dim; j++){
            C[i][j] = 0.0;
            for(k = 0; k < dim; k++){
                C[i][j] += A[i][k] * B[k][j];
            }
        }
    }
}

void liberarMemoria(float **matriz, int fil, int col){
    int j;

    for (j = 0; j < fil; j++){
        free(matriz[j]);
    }
    free(matriz);
}

int main(void){
    float **A, **B, **C;
    int dim;

    printf("Nmero de filas: ");
    scanf("%d", &dim);
    A = reservarMemoria(dim, dim);
    B = reservarMemoria(dim, dim);
    C = reservarMemoria(dim, dim);
    system ("cls");
    printf("Introduzca los datos de la primera matriz: ");
    leerMatriz(A,dim, dim);
    system ("cls");
    printf("Introduzca los datos de la segunda matriz");
    leerMatriz(B,dim, dim);
    multiplicarMatriz(A, B, C, dim);
    imprimirMatriz(C, dim, dim);
    liberarMemoria(A, dim, dim);
    liberarMemoria(B, dim, dim);
    liberarMemoria(C, dim, dim);
}
